const errors = require('../errors.json');
const multiplexer = require('../multiplexer/getuser');

exports.run = async (client, message, args, connection) => {
    if (!message.member.hasPermission('BAN_MEMBERS')) {
        message.channel.send(errors.insufficient_permission_for_user).catch(() => {
            return;
        });
        return;
    };

    const user = message.guild.members.cache.get(multiplexer.GetUser(args[0]));
    if (!user) {
        message.channel.send(errors.insufficient_args).catch(() => {
            return;
        });
        return;
    };

    let reason = args.slice(1).join(' ');
    if (reason == null) {
        reason = "Unspecified."
    };

    if(message.guild.member(user).roles.highest.position >= message.member.roles.highest.position) {
        message.channel.send(errors.equal_or_more_permission).catch(() => {
            return;
        });
        return;
    };

    if (!message.guild.member(user).bannable) {
        message.channel.send(errors.insufficient_permission_for_bot).catch(() => {
            return;
        });
        return;
    };
    await message.guild.member(user).ban({reason: reason}).catch(() => {
        message.channel.send(errors.unknown_error).catch(() => {
            return;
        });
        return;
    });

    message.channel.send('Successfully performed ban on specified user.').catch(() => {
        return;
    });
};

module.exports.help = {
    name: 'ban',
    aliases: []
};