const errors = require('../errors.json');
exports.run = async (client, message, args, connection) => {
    if (!message.member.hasPermission('MANAGE_MESSAGES')) {
        message.channel.send(errors.insufficient_permission_for_user).catch(() => {
            return;
        });
    };

    const amount = parseInt(args[0])
    if (!amount) {
        message.channel.send(errors.insufficient_args).catch(() => {
            return;
        });
        return;
    };
    if (amount > 100) {
        message.channel.send("Cannot delete more than 100 messages.").catch(() => {
            return;
        });
    };
    message.channel.bulkDelete(amount).catch(() => {
        message.channel.send(errors.insufficient_permission_for_bot).catch(() => {
            return;
        });
        return
    });
    message.channel.send(`Deleted ${args[0]} messages.`).catch(() => {
        return;
    });
};

module.exports.help = {
    name: 'clear',
    aliases: ['purge']
};