const Discord = require('discord.js');
const errors = require('../errors.json');
const moment = require('moment');

exports.run = async (client, message, args, connection) => {
    const embed = new Discord.MessageEmbed()
    .setTitle(`Info about ${message.guild.name}`)
    .addField("Guild ID", message.guild.id)
    .addField("Guild's owner", `<@!${message.guild.owner.id}> (${message.guild.owner.id})`)
    .addField("Role count", message.guild.roles.cache.size)
    .addField("Channel count", message.guild.channels.cache.size)
    .addField("Member size", message.guild.members.cache.size)
    .addField("Region", message.guild.region)
    .addField("Created time", `${moment(message.guild.createdTimestamp).format('LT')} ${moment(message.guild.createdTimestamp).format('LL')} [${moment(message.guild.createdTimestamp).fromNow()}]`)
    .addField("Emoji count", message.guild.emojis.cache.size)
    .addField("Boosts", `${message.guild.premiumSubscriptionCount || '0'}`)
    .setColor(0x33eeff);
    message.channel.send(embed).catch(() => {
        message.channel.send(errors.cannot_send_embed).catch(() => {
            return;
        });
        return;
    });
};

module.exports.help = {
    name: 'guild_info',
    aliases: ['guildinfo', 'guild-info']
};