const errors = require('../errors.json');

exports.run = async (client, message, args, connection) => {
    if (!message.member.hasPermission('KICK_MEMBERS')) {
        message.channel.send(errors.insufficient_permission_for_user).catch(() => {
            return;
        });
        return;
    };

    const user = message.mentions.users.first() || message.guild.members.cache.get(args[0]);
    if (!user) {
        message.channel.send(errors.insufficient_args).catch(() => {
            return;
        });
        return;
    };

    let reason = args.slice(1).join(' ');
    if (reason == null) {
        reason = "Unspecified."
    };

    if(message.guild.member(user).roles.highest.position >= message.member.roles.highest.position) {
        message.channel.send(errors.equal_or_more_permission).catch(() => {
            return;
        });
        return;
    };

    if (!message.guild.member(user).kickable) {
        message.channel.send(errors.insufficient_permission_for_bot).catch(() => {
            return;
        });
        return;
    };

    await message.guild.member(user).kick({reason: reason}).catch(() => {
        message.channel.send(errors.unknown_error).catch(() => {
            return;
        });
        return;
    });

    message.channel.send('Successfully performed kick on specified user.').catch(() => {
        return;
    });
};

module.exports.help = {
    name: 'kick',
    aliases: []
};