const errors = require('../errors.json');
const config = require('../config.json');

exports.run = async (client, message , args, connection) => {
    if(!message.member.hasPermission('ADMINISTRATOR')) {
            message.channel.send(errors.insufficient_permission_for_user).catch(() => {
            return;
        });
    };
    if (!args[0]) {
        message.channel.send(`${errors.insufficient_args}`).catch(() => {
            return;
        });
        return;
    };

    let channel;
    const channeldb = await new Promise((resolve, reject) => {
        connection.query(`SELECT channel FROM log_channel WHERE guild ='${message.guild.id}'`, function (err, result) {
            if (err)
                reject(err);
            resolve(result);
        });
    });
    if (channeldb.length < 1) {
        channel = "none";
    } else {
        channel = channeldb[0].channel;
    };
    if (args[0] == "reset") {
        if (channel == "none"){
            message.channel.send(errors.not_existing_on_db).catch(() => {
                return;
            });
            return;
        } else {
            await connection.query(`DELETE FROM log_channel WHERE guild ='${message.guild.id}'`, function (err, result) {
                if (err){
                    throw err;
                };
            });
            message.channel.send('Successful!').catch(() => {
                return;
            });
        };
    } else if (!message.mentions.channels.first()) {
        message.channel.send(errors.insufficient_args).catch(() => {
            return;
        });
    } else if (message.mentions.channels.first()) {
        if (channel == "none") {
            connection.query(`INSERT INTO log_channel (guild, channel) VALUES ('${message.guild.id}', '${message.mentions.channels.first().id}')`, function (err, result) {
                if (err) {
                    throw err;
                };
            });
            message.channel.send(`Successful!`).catch(() => {
                return;
            });
            return;
        } else {
            const prefixdb = await new Promise((resolve, reject) => {
                connection.query(`SELECT prefix FROM prefixes WHERE guild ='${message.guild.id}'`, function (err, result) {
                    if (err)
                        reject(err);
                    resolve(result);
                });
            });
            var prefix;
            if(prefixdb.length < 1) {
                prefix = config.prefix;
                } else {
                prefix = prefixdb[0].prefix;
            };
            message.channel.send(`Log channel is already existing. To reset type \`${prefix}log reset\`.`).catch(() => {
                return;
            });
        };
    };
};

module.exports.help = {
    name: 'log',
    aliases: ['log-channel', 'set-log']
};
