const errors = require('../errors.json');
const config = require('../config.json');

exports.run = async (client, message , args, connection) => {
    if(!message.member.hasPermission('ADMINISTRATOR')) {
            message.channel.send(errors.insufficient_permission_for_user).catch(() => {
            return;
        });
    };
    if (!args.join(' ')) {
        message.channel.send(errors.insufficient_args).catch(() => {
            return;
        });
        return;
    };
    const prefixdb = await new Promise((resolve, reject) => {
        connection.query(`SELECT prefix FROM prefixes WHERE guild ='${message.guild.id}'`, function (err, result) {
            if (err)
                reject(err);
            resolve(result);
        });
    });
    var prefix;
    if(prefixdb.length < 1) {
        prefix = config.prefix;
        } else {
        prefix = prefixdb[0].prefix;
    };
    if (args[0] == "reset") {
        if (prefix == config.prefix) {
            message.channel.send('You didn\'t edited the prefix, so you can\'t reset.').catch(() => {
                return;
            });
            return;
        } else {
            connection.query(`DELETE FROM prefixes WHERE guild ='${message.guild.id}'`, function (err) {
                if (err) {
                    throw err;
                };
            });
            message.channel.send('Resetting...').catch(() => {
                return;
            });
        };
        return;
    } else if (args[0] == prefix) {
        message.channel.send(`Prefix is already ${prefix}`).catch(() => {
            return;
        });
        return;
    } else {
        if (prefix == config.prefix) {
            connection.query(`INSERT INTO prefixes (prefix, guild) VALUES ('${args[0]}', '${message.guild.id}')`, function (err) {
                if (err) {
                    throw err;
                };
                message.channel.send('Updated prefix.').catch(() => {
                    return;
                });
            });
        } else {
            if (args[0] == config.prefix) {
                connection.query(`DELETE FROM prefixes WHERE guild ='${message.guild.id}'`, function (err) {
                    if (err) {
                        throw err;
                    };
                });
                message.channel.send('Updated prefix.').catch(() => {
                    return;
                });
                return;
            } else {
                connection.query(`UPDATE prefixes SET prefix ='${args[0]}' WHERE guild ='${message.guild.id}'`, function (err) {
                    if (err) {
                        throw err;
                    };
                });
                message.channel.send('Updated prefix.').catch(() => {
                    return;
                });
            }
        };
    };
};

module.exports.help = {
    name: 'prefix',
    aliases: ['set-prefix']
};
