const errors = require('../errors.json');
const multiplexer = require('../multiplexer/getuser');

exports.run = async (client, message, args) => {
    if (!message.member.hasPermission('BAN_MEMBERS')) {
        message.channel.send(errors.insufficient_permission_for_user).catch(() => {
            return;
        });
        return;
    };

    const user = args[0]
    if (!user) {
        message.channel.send(errors.insufficient_args).catch(() => {
            return;
        });
        return;
    };

    let reason = args.slice(1).join(' ');
    if (!reason) {
        reason = "Unspecified."
    }

    message.guild.fetchBans().then(bans => {
        if(bans.size == 0) {
            message.channel.send('There is no ban on this guild.').catch(() => {
                return;
            });
            return;
        };
        const ban = bans.find(b => b.user.id == multiplexer.GetUser(user));
        if (!ban) {
            message.channel.send('Cannot find that user or that user is not banned.').catch(() => {
                return;
            });
            return
        };
        message.guild.members.unban(ban.user).catch(() => {
            message.channel.send(errors.insufficient_permission_for_bot).catch(() => {
                return;
            });
            return;
        });
        message.channel.send('Successfully performed unban on specified user.').catch(() => {
            return;
        });
    });
};

module.exports.help = {
    name: 'unban',
    aliases: []
};