const errors = require('../errors.json');
const config = require('../config.json');

exports.run = async (client, message, args, connection) => {
    if(!message.member.hasPermission('ADMINISTRATOR')) {
            message.channel.send(errors.insufficient_permission_for_user).catch(() => {
            return;
        });
    };
    if (!args.join(' ')) {
        message.channel.send(`${errors.insufficient_args}`).catch(() => {
            return;
        });
        return;
    };
    const prefixdb = await new Promise((resolve, reject) => {
        connection.query(`SELECT prefix FROM prefixes WHERE guild ='${message.guild.id}'`, function (err, result) {
            if (err)
                reject(err);
            resolve(result);
        });
    });
    var prefix;
    if(prefixdb.length < 1) {
        prefix = config.prefix;
        } else {
        prefix = prefixdb[0].prefix;
    };

    connection.query(`SELECT message FROM welcome_message WHERE guild ='${message.guild.id}'`, function (err, result) {
        if (err) {
            throw err;
        };
        if (result.length < 1) {
            if (args[0] == "reset") {
                message.channel.send(errors.not_existing_on_db).catch(() => {
                    return;
                });
                return;
            };
            connection.query(`INSERT INTO welcome_message (guild, message) VALUES ('${message.guild.id}', '${args.join(' ')}')`, function (err, result) {
                if (err) {
                    throw err;
                };
            });
            message.channel.send('Successful!').catch(() => {
                return;
            });
        } else {
            if (args[0] == "reset") {
                connection.query(`DELETE FROM welcome_message WHERE guild ='${message.guild.id}'`, function (err, result) {
                    if (err) {
                        throw err;
                    };
                });
                message.channel.send('Resetting...').catch(() => {
                    return;
                });    
            } else {
                message.channel.send(`Welcome message is already existing. To reset type \`${prefix}welcome-message reset\`.`).catch(() => {
                    return;
                });
            };
        };
    });
};

module.exports.help = {
    name: 'welcome-message',
    aliases: ['welcome_message', 'welcomemessage']
};
